Support mmdebstrap via DEBOOTSTRAP=mmdebstrap
[grml-debootstrap.git] / grml-debootstrap
1 #!/bin/bash
2 # Filename:      grml-debootstrap
3 # Purpose:       wrapper around debootstrap for installing plain Debian via Grml
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2+
7 ################################################################################
8
9 # error_handler {{{
10 [ -n "$REPORT_TRAP_ERR" ] || REPORT_TRAP_ERR='no'
11 [ -n "$FAIL_TRAP_ERR" ] || FAIL_TRAP_ERR='no'
12
13 error_handler() {
14    last_exit_code="$?"
15    last_bash_command="$BASH_COMMAND"
16    if [ "$REPORT_TRAP_ERR" = "yes" ]; then
17       echo "Unexpected non-zero exit code $last_exit_code in ${BASH_SOURCE[*]} at line ${BASH_LINENO[*]} detected!
18 last bash command: $last_bash_command"
19    fi
20    if [ ! "$FAIL_TRAP_ERR" = "yes" ]; then
21       return
22    fi
23    ## Check if "bailout" function is available.
24    ## This is not the case in chroot-script.
25    if command -v bailout >/dev/null 2>&1; then
26       bailout 1
27    else
28       echo 'FAIL_TRAP_ERR is set to "yes", exit 1.'
29       exit 1
30    fi
31 }
32
33 if [ "$REPORT_TRAP_ERR" = "yes" ] || [ "$FAIL_TRAP_ERR" = "yes" ]; then
34    set -E
35    set -o pipefail
36    trap "error_handler" ERR
37    export -f "error_handler"
38 fi
39 # }}}
40
41 # variables {{{
42 PN="$(basename "$0")"
43 if [[ -d "$(dirname "$(command -v "$0")")"/.git ]]; then
44   VERSION="$(git describe | sed 's|^v||')"
45 else
46   VERSION="$(dpkg-query --show --showformat='${Version}' "$PN")"
47 fi
48 VERSION="${VERSION:-unknown}"
49 MNTPOINT="/mnt/debootstrap.$$"
50
51 # defaults
52 [ -n "$CHROOT_SCRIPTS" ] || CHROOT_SCRIPTS='yes'
53 [ -n "$CONFFILES" ] || CONFFILES='/etc/debootstrap'
54 [ -n "$DEBCONF" ] || DEBCONF='yes'
55 [ -n "$DEBIAN_FRONTEND" ] || DEBIAN_FRONTEND='noninteractive'
56 [ -n "$DEBOOTSTRAP" ] || DEBOOTSTRAP='debootstrap'
57 [ -n "$DEFAULT_LANGUAGE" ] || DEFAULT_LANGUAGE='en_US:en'
58 [ -n "$DEFAULT_LOCALES" ] || DEFAULT_LOCALES='en_US.UTF-8'
59 [ -n "$DISK_IDENTIFIER" ] || DISK_IDENTIFIER='26ada0c0-1165-4098-884d-aafd2220c2c6'
60 [ -n "$EXTRAPACKAGES" ] || EXTRAPACKAGES='yes'
61 [ -n "$FALLBACK_MIRROR" ] || FALLBACK_MIRROR='http://deb.debian.org/debian'
62 [ -n "$FIXED_DISK_IDENTIFIERS" ] || FIXED_DISK_IDENTIFIERS="no"
63 [ -n "$FORCE" ] || FORCE=''
64 [ -n "$HOSTNAME" ] || HOSTNAME='grml'
65 [ -n "$INITRD" ] || INITRD='yes'
66 [ -n "$INSTALL_NOTES" ] || INSTALL_NOTES='/etc/debootstrap/install_notes'
67 [ -n "$LOCALES" ] || LOCALES='yes'
68 [ -n "$MIRROR" ] || MIRROR="$FALLBACK_MIRROR"
69 [ -n "$MKFS" ] || MKFS='mkfs.ext4'
70 [ -n "$MKFS_OPTS" ] || MKFS_OPTS=''
71 [ -n "$PACKAGES" ] || PACKAGES='yes'
72 [ -n "$POST_SCRIPTS" ] || POST_SCRIPTS='yes'
73 [ -n "$PRE_SCRIPTS" ] || PRE_SCRIPTS='yes'
74 [ -n "$RECONFIGURE" ] || RECONFIGURE='console-data'
75 [ -n "$RELEASE" ] || RELEASE='buster'
76 [ -n "$RM_APTCACHE" ] || RM_APTCACHE='yes'
77 [ -n "$SCRIPTS" ] || SCRIPTS='no' # deprecated, replaced by POST_SCRIPTS
78 [ -n "$SECURE" ] || SECURE='yes'
79 [ -n "$TIMEZONE" ] || TIMEZONE='Europe/Vienna'
80 [ -n "$TUNE2FS" ] || TUNE2FS='tune2fs -c0 -i0'
81 [ -n "$UPGRADE_SYSTEM" ] || UPGRADE_SYSTEM='yes'
82 [ -n "$VMSIZE" ] || VMSIZE="2G"
83 [ -n "$GRUB_INSTALL" ] || GRUB_INSTALL='yes'
84
85 # inside the chroot system locales might not be available, so use minimum:
86 export LANG=C
87 export LC_ALL=C
88 export LANGUAGE=C
89
90 # make sure interactive mode is only executed when
91 # using an empty configuration file or option --interactive
92 INTERACTIVE=''
93 # }}}
94
95 # help text {{{
96 usage() {
97   echo "$PN - wrapper around debootstrap for installing Debian
98
99 Usage: $PN [options]
100
101 Bootstrap options:
102
103   -m, --mirror <URL>     Mirror which should be used for apt-get/aptitude.
104   -i, --iso <mnt>        Mountpoint where a Debian ISO is mounted to, for use
105                          instead of fetching packages from a mirror.
106   -r, --release <name>   Release of new Debian system (default: buster).
107   -t, --target <target>  Target partition (/dev/...) or directory where the
108                          system should be installed to.
109   -p, --mntpoint <mnt>   Mountpoint used for mounting the target system,
110                          has no effect if -t is given and represents a directory.
111       --debopt <params>  Extra parameters passed to the debootstrap command.
112       --interactive      Use interactive mode (frontend).
113       --nodebootstrap    Skip debootstrap, only do configuration to the target.
114       --grub <device>    Target for grub installation. Usage example: /dev/sda
115       --efi <device>     Target for EFI installation. Usage example: /dev/sda1
116       --arch <arch>      Set target architecture, use for installing i386 on amd64.
117       --filesystem <fs>  Filesystem that should be used when target is a partition
118                          or Virtual Machine (see --vmfile).
119       --force            Do not prompt for user acknowledgement.
120
121 Options for Virtual Machine deployment:
122
123       --vm               Set up a Virtual Machine on an existing block device
124                          instead of plainly installing to a partition or
125                          directory. Needs to be combined with --target.
126                          Example: --vm --target /dev/mapper/your-vm-disk
127       --vmfile           Like --vm, but install into a regular file (created by
128                          'qemu-img create -f raw ...') instead.
129                          Example: --vmfile --target /mnt/sda1/qemu.img
130       --vmsize <size>    Use specified size for size of VM file (default: 2G).
131                          Syntax as supported by qemu-img, like: --vmsize 3G
132
133 Configuration options:
134
135   -c, --config <file>      Use specified configuration file, defaults to
136                              /etc/debootstrap/config
137   -d, --confdir <path>     Place of config files for debootstrap, defaults
138                              to /etc/debootstrap
139       --packages <file>    Install packages defined in specified list file
140                              instead of using /etc/debootstrap/packages.
141       --nopackages         Skip installation of packages defined in
142                              /etc/debootstrap/packages
143       --nokernel           Skip installation of default kernel images.
144       --nointerfaces       Do not copy /etc/network/interfaces from host system
145                            to target system.
146                            (This option is automatically enabled when using --vmfile.)
147       --defaultinterfaces  Install a default /etc/network/interfaces file (enabling
148                            DHCP for eth0) instead of taking over config from host system.
149       --debconf <file>     Pre-seed packages using specified pre-seed db file.
150       --grmlrepos          Enable Grml's Debian repository (deb.grml.org).
151       --backportrepos      Enable Debian's backports repository (backports.debian.org).
152       --keep_src_list      Do not overwrite user provided apt sources.list.
153       --contrib            Enable 'contrib' in COMPONENTS (defaults to 'main' only).
154       --non-free           Enable non-free in COMPONENTS (defaults to 'main' only).
155       --hostname <name>    Hostname of Debian system.
156       --nopassword         Do not prompt for the root password.
157       --password <pwd>     Use specified password as password for user root.
158       --bootappend <line>  Add specified appendline to kernel whilst booting.
159       --chroot-scripts <d> Execute chroot scripts from specified directory.
160       --pre-scripts <dir>  Execute scripts from specified directory (before chroot-scripts).
161       --scripts <dir>      Execute scripts from specified directory (after chroot-scripts).
162       --remove-configs     Delete grml-debootstrap configuration files from installed system.
163
164 Other options:
165
166   -v, --verbose            Increase verbosity.
167       --debug              Execute in very verbose way.
168   -h, --help               Print this usage information and exit.
169   -V, --version            Show summary of options and exit.
170
171 Usage examples can be found in the grml-debootstrap manpage.
172 Send bugreports to the grml-team: bugs (at) grml.org || http://grml.org/bugs/
173 "
174 }
175
176 if [ "$1" = '-h' ] || [ "$1" = '-help' ] || [ "$1" = "--help" ] ; then
177    usage
178    echo 'Please notice that this script requires root permissions!'
179    exit 0
180 fi
181 # }}}
182
183 # early helper functions {{{
184 GOOD='\e[32;01m'
185 BAD='\e[31;01m'
186 WARN='\e[33;01m'
187 NORMAL='\e[0m'
188
189 einfo() {
190   einfon "$1\\n"
191   return 0
192 }
193
194 einfon() {
195   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
196   printf " %s*%s $*" "${GOOD}" "${NORMAL}"
197   LAST_E_CMD=einfon
198   return 0
199 }
200
201 ewarn() {
202   printf " %s*%s $*\\n" "${WARN}" "${NORMAL}"
203   return 0
204 }
205
206 eerror() {
207   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
208   printf " %s*%s $*\\n" "${BAD}" "${NORMAL}" >&2
209   LAST_E_CMD=eerror
210   return 0
211 }
212
213 eend() {
214   local retval="${1:-0}"
215   shift
216   if [ "$retval" -gt 0 ]; then
217     printf " %s-> Failed (rc=%s)%s\\n" "${BAD}" "${retval}" "${NORMAL}"
218   fi
219   return "$retval"
220 }
221
222 check4root(){
223   if [ "$(id -u 2>/dev/null)" != 0 ] ; then
224     echo 1>&2 "Error: please run this script with uid 0 (root)." ; return 1
225   fi
226 }
227
228 check4progs(){
229   local RC=''
230   for arg in "$@" ; do
231     command -v "$arg" >/dev/null 2>&1 || RC="$arg"
232   done
233   if [ -n "$RC" ] ; then
234      echo "$RC not installed"
235      return 1
236   fi
237 }
238 # }}}
239
240 # helper functions {{{
241 cleanup() {
242   if [ -n "$CHROOT_VARIABLES" ] ; then
243     einfo "Removing ${CHROOT_VARIABLES}" ; rm "$CHROOT_VARIABLES" ; eend $?
244   fi
245
246   if [ -n "$STAGES" ] ; then
247     einfo "Removing ${STAGES}" ; rmdir "$STAGES" ; eend $?
248   fi
249
250   # Remove temporary mountpoint again
251   if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
252     rmdir "$MNTPOINT" 2>/dev/null
253   fi
254
255   # make sure $TARGET is not mounted when exiting grml-debootstrap
256   if [ -n "$MNTPOINT" ] ; then
257     if grep -q "$MNTPOINT" /proc/mounts ; then
258       # make sure nothing is left inside chroot so we can unmount it
259       for service in ssh mdadm ; do
260         if [ -x "${MNTPOINT}/etc/init.d/${service}" ] ; then
261           chroot "$MNTPOINT" "/etc/init.d/${service}" stop
262         fi
263       done
264
265       [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a >/dev/null 2>&1
266
267       # ugly, but make sure we really don't leave anything (/proc /proc and
268       # /dev /dev are intended, trying to work around timing issues, see #657023)
269       for ARG in /run/udev /sys /proc /proc /dev/pts /dev/pts /dev /dev ; do
270         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount $ARG >/dev/null 2>&1
271         umount "$MNTPOINT"/$ARG >/dev/null 2>&1
272       done
273
274       if [ -n "$ISODIR" ] ; then
275         [ -d "$MNTPOINT/$ISODIR" ] && umount "$MNTPOINT/$ISODIR" >/dev/null 2>&1
276       fi
277
278       if [ -n "$DIRECTORY" ] ; then
279         einfo "Not unmounting $MNTPOINT as you requested me to install into a directory of your own choice." ; eend 0
280       else
281         einfo "Unmounting $MNTPOINT"
282         umount "$MNTPOINT"
283         eend $?
284       fi
285
286       if [ -n "$STAGES" ] ; then
287         echo -n "Removing stages directory ${STAGES}: "
288         rm -rf "$STAGES" && echo 'done'
289       fi
290
291       # remove directory only if we used the default with process id inside the name
292       if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
293         einfo "Removing directory ${MNTPOINT}"
294         rmdir "$MNTPOINT"
295         eend $?
296       fi
297     fi
298   fi
299
300   if [ -n "${ORIG_TARGET}" ] ; then
301     einfo "Removing loopback mount of file ${ORIG_TARGET}."
302     kpartx -d "${ORIG_TARGET}"
303     # Workaround for a bug in kpartx which doesn't clean up properly,
304     # see Debian Bug #891077 and Github-PR grml/grml-debootstrap#112
305     if dmsetup ls | grep -q "^${LOOP_PART} "; then
306       kpartx -d "/dev/${LOOP_DISK}" >/dev/null
307     fi
308     eend $?
309   fi
310 }
311
312 # we want to exit smoothly and clean:
313 bailout(){
314
315   cleanup
316
317   [ -n "$1" ] && EXIT="$1" || EXIT="1"
318   [ -n "$2" ] && einfo "Notice: remove $STAGES/$2 to reexecute the stage"
319
320   exit "$EXIT"
321 }
322 trap bailout HUP INT QUIT TERM
323
324 # we want to execute all the functions only once, simple check for it:
325 stage() {
326   if [ -n "$2" ] ; then
327      echo "$2" > "${STAGES}/${1}"
328      return 0
329   elif grep -q 'done' "${STAGES}/${1}" 2>/dev/null ; then
330      ewarn "Notice: stage $1 has been executed already, skipping execution therefore." ; eend 0
331      ewarn "  To reexecute it clean up the according directory inside $STAGES" ; eend 0
332      return 1
333   fi
334 }
335 # }}}
336
337 # make sure we have what we need {{{
338 check4progs "${DEBOOTSTRAP}" || bailout 1
339 # }}}
340
341 # source main configuration file {{{
342 if [ -r /etc/debootstrap/config ] ; then
343   # shellcheck disable=SC1091
344   . /etc/debootstrap/config
345 fi
346 # }}}
347
348 # cmdline handling {{{
349 CMDLINE_OPTS=mirror:,iso:,release:,target:,mntpoint:,debopt:,defaultinterfaces,interactive,nodebootstrap,nointerfaces,nokernel,nopackages,filesystem:,config:,confdir:,packages:,chroot-scripts:,scripts:,post-scripts:,pre-scripts:,debconf:,vm,vmfile,vmsize:,keep_src_list,hostname:,password:,nopassword,grmlrepos,backportrepos,bootappend:,grub:,efi:,arch:,insecure,verbose,help,version,force,debug,contrib,non-free,remove-configs
350
351 _opt_temp=$(getopt --name grml-debootstrap -o +m:i:r:t:p:c:d:vhV --long \
352   $CMDLINE_OPTS -- "$@")
353
354 if [ $? != 0 ]; then
355   eerror "Try 'grml-debootstrap --help' for more information."; eend 1; exit 1
356 fi
357 eval set -- "$_opt_temp"
358
359 while :; do
360   case "$1" in
361
362   # == Bootstrap options
363   --mirror|-m)         # Mirror which should be used for apt-get/aptitude
364     shift; _opt_mirror="$1"
365     ;;
366   --iso|-i)            # Mountpoint where a Debian ISO is mounted to
367     shift; _opt_iso="$1"
368     ;;
369   --release|-r)        # Release of new Debian system
370     shift; _opt_release="$1"
371     ;;
372   --target|-t)         # Target partition (/dev/...) or directory
373     shift; _opt_target="$1"
374     ;;
375   --vm)                # Virtual machine image (no file)
376     _opt_vm="T"
377     ;;
378   --vmfile)            # Virtual machine file
379     _opt_vmfile="T"
380     ;;
381   --vmsize)            # size of Virtual machine file
382     shift; _opt_vmsize="$1"
383     ;;
384   --mntpoint|-p)       # Mountpoint used for mounting the target system
385     shift; _opt_mntpoint="$1"
386     ;;
387   --debopt)            # Extra parameters passed to the debootstrap command
388     shift; _opt_debopt="$1"
389     ;;
390   --filesystem)        # Filesystem that should be used
391     shift; _opt_filesystem="$1"
392     ;;
393   --interactive)       # Use interactive mode (frontend)
394     _opt_interactive=T
395     ;;
396   --nodebootstrap)     # Skip debootstrap, only do configuration to the target
397     _opt_nodebootstrap=T
398     ;;
399   --nopackages)        # Skip installation of packages defined in /etc/debootstrap/packages
400     _opt_nopackages=T
401     ;;
402   --arch)              # Target architecutre
403     shift; _opt_arch="$1"
404     ;;
405   # just for backwards compatibility
406   --insecure)
407     _opt_insecure=T
408     ;;
409   #
410
411   # == Configuration options
412   --config|-c)         # Use specified configuration file, defaults to /etc/debootstrap
413     shift; _opt_config="$1"
414     ;;
415   --confdir|-d)        # Place of config files for debootstrap, defaults to /etc/debootstrap
416     shift; _opt_confdir="$1"
417     ;;
418   --packages)          # Install packages defined in specified file
419     shift; _opt_packages="$1"
420     _opt_packages_set=T
421     ;;
422   --debconf)           # Pre-seed packages using specified file
423     shift; _opt_debconf="$1"
424     _opt_debconf_set=T
425     ;;
426   --pre-scripts)       # Execute scripts from specified directory (before chroot-scripts).
427     shift; _opt_pre_scripts="$1"
428     _opt_pre_scripts_set=T
429     ;;
430   --scripts)           # Execute scripts from specified directory [NOTE: deprecated, replaced via --post-scripts]
431     shift; _opt_scripts="$1"
432     _opt_scripts_set=T
433     ;;
434   --post-scripts)       # Execute scripts from specified directory
435     shift; _opt_post_scripts="$1"
436     _opt_post_scripts_set=T
437     ;;
438   --chroot-scripts)   # Execute chroot scripts from specified directory
439     shift; _opt_chroot_scripts="$1"
440     _opt_chroot_scripts_set=T
441     ;;
442   --keep_src_list)     # Do not overwrite user provided apt sources.list
443     _opt_keep_src_list=T
444     ;;
445   --hostname)          # Hostname of Debian system
446     shift; _opt_hostname="$1"
447     ;;
448   --password)          # Use specified password as password for user root
449     shift; _opt_password="$1"
450     ;;
451   --defaultinterfaces) # Install default /etc/network/interfaces
452     _opt_defaultinterfaces=T
453     ;;
454   --nointerfaces)      # Skip installation of /etc/network/interfaces
455     _opt_nointerfaces=T
456     ;;
457   --nokernel)          # Skip installation of default kernel images
458     _opt_nokernel=T
459     ;;
460   --nopassword)        # Skip password dialog
461     _opt_nopassword=T
462     ;;
463   --grmlrepos)         # Enable Grml repository
464     _opt_grmlrepos=T
465     ;;
466   --backportrepos)     # Enable Debian backports repository
467     _opt_backportrepos=T
468     ;;
469   --bootappend)        # Add specified appendline to kernel whilst booting
470     shift; _opt_bootappend="$1"
471     ;;
472   --grub)              # Target for grub installation. Use grub syntax for specifying
473     shift; _opt_grub="$1"
474     ;;
475   --efi)               # Target for EFI boot installation
476     shift; _opt_efi="$1"
477     ;;
478   --contrib)           # Add 'contrib' to list of components
479     _opt_contrib=T
480     ;;
481   --non-free)          # Add 'non-free' to list of components
482     _opt_non_free=T
483     ;;
484   --remove-configs)    # Drop config files from installed system
485     _opt_remove_configs=T
486     ;;
487
488   # == Other options
489   --verbose|-v)        # Increase verbosity
490     if [ "$_opt_verbose" ]; then
491       _opt_verbose=$( _opt_verbose + 1 )
492     else
493       _opt_verbose=1
494     fi
495     ;;
496   --debug)             # Execute in debug mode
497     _opt_debug=T
498     ;;
499   --help|-h)           # Print usage information and exit
500     _opt_help=T
501     ;;
502   --version|-V)        # Show version information and exit
503     _opt_version=T
504     ;;
505   --force)             # Do not prompt for user input
506     _opt_force=T
507     ;;
508   --)
509     shift; break
510     ;;
511   *)
512     eerror "Internal getopt error!"; eend 1 ; exit 1
513     ;;
514   esac
515   shift
516 done
517
518 # == business-logic of command line parameter-processing
519
520 # source configuration file in <confdir> if supplied. {{{
521 [ "$_opt_confdir" ] && {
522   CONFFILES=$_opt_confdir
523   einfo "Using config files under $CONFFILES/."
524   if ! [ -r "$CONFFILES/config" ] ; then
525     eerror "Error: config file $CONFFILES/config not found."; eend 1; bailout 1
526   fi
527   # shellcheck disable=SC1091 source=config
528   if ! . "$CONFFILES/config" ; then
529     eerror "Error reading config file $CONFFILES/config" ; eend 1 ; bailout 1
530   fi
531   # restore the command line parameter value
532   CONFFILES=$_opt_confdir
533 }
534 # }}}
535
536 [ "$_opt_mirror" ]              && MIRROR=$_opt_mirror
537 [ "$_opt_iso" ]                 && ISO=$_opt_iso
538 [ "$_opt_release" ]             && RELEASE=$_opt_release
539 [ "$_opt_target" ]              && TARGET=$_opt_target
540 [ "$_opt_vm" ]                  && VIRTUAL=1
541 [ "$_opt_vmfile" ]              && VMFILE=1 && VIRTUAL=1
542 [ "$_opt_vmsize" ]              && VMSIZE=$_opt_vmsize
543 [ "$_opt_mntpoint" ]            && MNTPOINT=$_opt_mntpoint
544 [ "$_opt_debopt" ]              && DEBOOTSTRAP_OPT=$_opt_debopt
545 [ "$_opt_interactive" ]         && INTERACTIVE=1
546 [ "$_opt_config" ]              && CONFIGFILE=$_opt_config
547 [ "$_opt_filesystem" ]          && MKFS="mkfs.$_opt_filesystem"
548 [ "$_opt_packages_set" ]        && PACKAGES='yes'
549 [ "$_opt_nopackages" ]          && PACKAGES=''
550 [ "$_opt_debconf_set" ]         && DEBCONF='yes'
551 [ "$_opt_post_scripts_set" ]    && POST_SCRIPTS='yes'
552 [ "$_opt_pre_scripts_set" ]     && PRE_SCRIPTS='yes'
553 [ "$_opt_chroot_scripts_set" ]  && CHROOT_SCRIPTS='yes'
554 [ "$_opt_keep_src_list" ]       && KEEP_SRC_LIST='yes'
555 [ "$_opt_grmlrepos" ]           && GRMLREPOS='yes'
556 [ "$_opt_backportrepos" ]       && BACKPORTREPOS='yes'
557 [ "$_opt_hostname" ]            && HOSTNAME=$_opt_hostname
558 [ "$_opt_password" ]            && ROOTPASSWORD=$_opt_password
559 [ "$_opt_nopassword" ]          && NOPASSWORD='yes'
560 [ "$_opt_defaultinterfaces" ]   && USE_DEFAULT_INTERFACES="true"
561 [ "$_opt_nointerfaces" ]        && NOINTERFACES="true"
562 [ "$_opt_nokernel" ]            && NOKERNEL="true"
563 [ "$_opt_bootappend" ]          && BOOT_APPEND=$_opt_bootappend
564 [ "$_opt_grub" ]                && GRUB=$_opt_grub
565 [ "$_opt_efi" ]                 && EFI=$_opt_efi
566 [ "$_opt_arch" ]                && ARCH=$_opt_arch
567 [ "$_opt_insecure" ]            && echo "Warning: --insecure is deprecated, continuing anyway."
568 [ "$_opt_force" ]               && FORCE=$_opt_force
569 [ "$_opt_verbose" ]             && VERBOSE="-v"
570 [ "$_opt_debug" ]               && DEBUG="true"
571 [ "$_opt_remove_configs" ]      && REMOVE_CONFIGS="yes"
572
573 # make sure main is always included
574 [ -z "$COMPONENTS" ]            && COMPONENTS="main"
575 [ "$_opt_contrib" ]             && COMPONENTS="$COMPONENTS contrib"
576 [ "$_opt_non_free" ]            && COMPONENTS="$COMPONENTS non-free"
577
578 # command line option checks
579 if [ "$_opt_scripts_set" ] ; then
580   ewarn "Deprecation NOTE: --scripts option is deprecated, please switch to --post-scripts instead."
581   SCRIPTS='yes' # deprecated since grml-debootstrap >=0.71
582 fi
583
584 if [ "$_opt_grub" ] && [ "$_opt_vmfile" ] ; then
585   eerror "The --grub option is incompatible with --vmfile, please drop it from your command line."
586   eerror "The --grub option is unneeded as GRUB will be installed automatically."
587   eend 1
588   bailout 1
589 fi
590
591 if [ -n "$ISO" ] && [[ "$DEBOOTSTRAP" =~ mmdebstrap$ ]] ; then
592   eerror "The ISO option is incompatible with usage of mmdebstrap for bootstrapping."
593   eerror "Either drop the --iso ... option or use plain debootstrap instead."
594   eend 1
595   bailout 1
596 fi
597
598 if [ "$DEBUG" = "true" ] ; then
599   set -x
600 fi
601
602 [ "$_opt_help" ] && {
603   usage ; eend 0
604   eend 0
605   exit 0
606 }
607
608 [ "$_opt_version" ] && {
609   einfo "$PN - version $VERSION"
610   einfo "Send bug reports to bugs@grml.org or http://grml.org/bugs/"
611   eend 0
612   exit 0
613 }
614 # }}}
615
616 # check for root permissions {{{
617 if ! check4root ; then
618    echo "For usage instructions please execute '$PN --help'."
619    bailout 1
620 fi
621 # }}}
622
623 # make sure we have what we need {{{
624 if [ -n "$VIRTUAL" ] ; then
625   check4progs kpartx parted qemu-img || bailout 1
626 fi
627 # }}}
628
629 # source specified configuration file {{{
630 if [ -n "$CONFIGFILE" ] ; then
631   einfo "Reading specified config file $CONFIGFILE."
632   # shellcheck disable=SC1091 source=config
633   if ! . "$CONFIGFILE" ; then
634     eerror "Error reading config file $CONFIGFILE" ; eend 1 ; bailout 1
635   fi
636 fi
637 # }}}
638
639 # backwards compatibility checks {{{
640 if [ -n "$GROOT" ] ; then
641    eerror "Error: you seem to have \$GROOT configured."
642    eerror "This variable is no longer supported, please visit the"
643    eerror "grml-debootstrap documentation for details."
644    eend 1
645    bailout 1
646 fi
647
648 if echo "$GRUB" | grep -q '^hd' ; then
649    eerror "Error: this syntax for the grub configuration variable is no longer supported."
650    eerror "Please do not use hd... any longer but /dev/sdX instead."
651    eend 1
652    bailout 1
653 fi
654 # }}}
655
656 # welcome screen {{{
657 welcome_dialog()
658 {
659    dialog --title "$PN" --yesno "Welcome to the interactive configuration of ${PN}.
660 Do you want to continue installing Debian using this frontend?" 0 0 || bailout 0
661 }
662 # }}}
663
664 # ask for target {{{
665 prompt_for_target()
666 {
667   AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
668                sed 's/*//' | \
669                grep -v 'Extended$' | \
670                gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}'; ls /dev/md[0-9]* 2>/dev/null || true);
671
672   if [ -z "$AVAILABLE_PARTITIONS" ] ; then
673      dialog --title "$PN" --trim \
674      --msgbox "Sorry, no partitions found. Please configure your
675      harddisks (see /proc/partitions) using a tool like fdisk,
676      cfdisk, gpart, gparted,..." 0 0
677      bailout 1
678   fi
679
680   PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
681                      fs="$(blkid -s TYPE -o value "$i" 2>/dev/null)"
682                      [ -n "$fs" ] || fs='[no_filesystem_yet]'
683                      echo "$i" "$fs"
684                      unset fs
685                    done)
686
687   # shellcheck disable=SC2086
688   TARGET=$(dialog --title "$PN" --single-quoted --stdout \
689          --menu "Please select the target partition:" 0 0 0 \
690          $PARTITION_LIST)
691   [ $? -eq 0 ] || bailout 1
692 }
693 # }}}
694
695 # ask for bootmanager {{{
696 prompt_for_bootmanager()
697 {
698   ADDITIONAL_PARAMS=""
699
700   if echo "$TARGET" | grep -q "/dev/md" ; then
701      MBRPART="all disks of Software RAID $TARGET"
702   else
703      # figure out whole disk device
704      found=
705      for device in /dev/disk/by-id/*
706      do
707         [ "$(readlink -f "$device")" = "${TARGET}" ] || continue
708         found=1
709         break
710      done
711      # shellcheck disable=SC2001
712      [ -n "$found" ] && MBRDISK=$(echo "${device}" | sed -e 's/-part[0-9][0-9]*$//')
713      if [ -e "$MBRDISK" ]; then
714         MBRDISK=$(readlink -f "$MBRDISK")
715      else
716         # fall back to old behaviour
717         # shellcheck disable=SC2001
718         MBRDISK=$(echo "${TARGET}" | sed -e 's/[0-9][0-9]*$//')
719      fi
720
721      MBRPART="MBR of $MBRDISK"
722   fi
723
724   for device in cciss/c0d0 sda hda; do
725     if [ "/dev/$device" != "${MBRDISK}" ]; then
726       grep -q $device /proc/partitions && \
727       ADDITIONAL_PARAMS="$ADDITIONAL_PARAMS:$device:install bootmanager grub into MBR of /dev/$device"
728     fi
729   done
730   ADDITIONAL_PARAMS=${ADDITIONAL_PARAMS#:}
731
732   OIFS="$IFS"; IFS=:
733
734   # shellcheck disable=SC2086
735   GETMBR=$(dialog --stdout --title "$PN" --default-item mbr \
736           --menu "Where do you want to install the bootmanager grub?" 0 0 0 \
737             mbr       "install bootmanager into $MBRPART" \
738             nowhere   "do not install bootmanager at all" \
739           ${ADDITIONAL_PARAMS})
740   [ $? -eq 0 ] || bailout 3
741   IFS="$OIFS"
742
743   case "$GETMBR" in
744     mbr)
745       # /dev/md0: has to be installed in MBR of /dev/md0 and not in /dev/md:
746       if echo "$TARGET" | grep -q "/dev/md" ; then
747         GRUB="$TARGET"
748       else
749         GRUB="$MBRDISK"
750       fi
751       ;;
752     hda)
753       GRUB="/dev/hda"
754       ;;
755     sda)
756       GRUB="/dev/sda"
757       ;;
758     nowhere)
759       GRUB=''
760       ;;
761   esac
762 }
763 # }}}
764
765 # ask for Debian release {{{
766 prompt_for_release()
767 {
768   [ -n "$RELEASE" ] && DEFAULT_RELEASE="$RELEASE" || DEFAULT_RELEASE='buster'
769   RELEASE="$(dialog --stdout --title "${PN}" --default-item $DEFAULT_RELEASE --menu \
770             "Please enter the Debian release you would like to use for installation:" \
771             0 50 8 \
772             lenny    Debian/5.0 \
773             squeeze  Debian/6.0 \
774             wheezy   Debian/7.0 \
775             jessie   Debian/8.0 \
776             stretch  Debian/9.0 \
777             buster   Debian/10.0 \
778             bullseye Debian/11.0 \
779             sid      Debian/unstable)"
780   [ $? -eq 0 ] || bailout
781 }
782 # }}}
783
784 # ask for hostname {{{
785 prompt_for_hostname()
786 {
787   HOSTNAME="$(dialog --stdout --title "${PN}" --inputbox \
788             "Please enter the hostname you would like to use for installation:" \
789             0 0 "$HOSTNAME")"
790   [ $? -eq 0 ] || bailout
791 }
792 # }}}
793
794 # ask for password {{{
795 prompt_for_password()
796 {
797   if [ "$_opt_nopassword" ] ; then
798     einfo "Skip asking for root password as requested."
799     return 0
800   fi
801
802   ROOTPW1='PW1'
803   ROOTPW2='PW2'
804   while [ "$ROOTPW1" != "$ROOTPW2" ]; do
805     ROOTPW1=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
806     "Please enter the password for the root account:" 10 60)
807     [ $? -eq 0 ] || bailout
808
809     ROOTPW2=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
810     "Please enter the password for the root account again for \
811     confirmation:" 10 60)
812     [ $? -eq 0 ] || bailout
813
814     if [ "$ROOTPW1" != "$ROOTPW2" ]; then
815       dialog --stdout --title "${PN}" --ok-label \
816         "Retry" --msgbox "Passwords do not match!" 10 60
817     fi
818   done
819   ROOTPASSWORD="$ROOTPW1"
820 }
821 # }}}
822
823 # ask for Debian mirror {{{
824 prompt_for_mirror()
825 {
826   [ -n "$ISO" ] && DEFAULT_MIRROR='local' || DEFAULT_MIRROR='net'
827
828   CHOOSE_MIRROR=$(dialog --stdout --title "$PN" --default-item $DEFAULT_MIRROR \
829           --menu "Where do you want to install from?" 0 0 0 \
830             net   "install via network (downloading from mirror)" \
831             local "install from local directory/mirror"
832           )
833   [ $? -eq 0 ] || bailout
834
835   if [ "$CHOOSE_MIRROR" = 'net' ] ; then
836      [ -n "$MIRROR" ] || MIRROR='http://deb.debian.org/debian'
837      MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
838                "Please enter Debian mirror you would like to use for installing packages." \
839                0 0 $MIRROR)"
840      [ $? -eq 0 ] || bailout
841   else # CHOOSE_MIRROR == local
842      [ -n "$ISO" ] || ISO='/mnt/mirror'
843      ISO="$(dialog --stdout --title "${PN}" --inputbox \
844                "Please enter directory name you would like to use for installing packages." \
845                0 0 $ISO)"
846      [ $? -eq 0 ] || bailout
847   fi
848 }
849 # }}}
850
851 # software raid setup {{{
852 config_swraid_setup()
853 {
854 TMPFILE=$(mktemp)
855
856 # Currently we support only raid1:
857 RAIDLEVEL='raid1'
858
859 MD_LIST=$(for i in $(seq 0 9) ; do
860             awk '{print $4}' /proc/partitions | grep -q "md$i" || \
861             echo "/dev/md$i /dev/md$i"
862           done)
863
864 # shellcheck disable=SC2086
865 TARGET=$(dialog --stdout --title "$PN" --default-item /dev/md0 \
866 --menu "Which device do you want to use for ${RAIDLEVEL}?
867
868 Notice: activated devices will not be listed for security reasons. Anyway, please make sure the selected device is not in use already!" 0 0 0 \
869 $MD_LIST)
870 [ $? -eq 0 ] || bailout 20
871
872 AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
873              sed 's/*//' | \
874              grep -v 'Extended$' | \
875              gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
876 [ -n "$AVAILABLE_PARTITIONS" ] || echo "Fatal error: no partitions available?"
877 PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
878                      echo "$i $(blkid -s TYPE -o value "$i" 2>/dev/null || echo '[no_filesystem_yet]') off"
879                  done)
880
881 # shellcheck disable=SC2086
882 dialog --title "$PN" --separate-output \
883        --checklist "Please select the partitions you would like to use for your $RAIDLEVEL on ${TARGET}:" 0 0 0 \
884        $PARTITION_LIST 2>"$TMPFILE"
885 [ $? -eq 0 ] || bailout
886 SELECTED_PARTITIONS="$(cat "$TMPFILE")"
887
888 NUM_PARTITIONS=0
889 while IFS= read -r i; do
890   NUM_PARTITIONS=$(( NUM_PARTITIONS + 1 ))
891 done < "$TMPFILE"
892
893 # force metadata version 0.90 for lenny so old grub can boot from this array.
894 METADATA_VERSION=""
895 if [ "$RELEASE" = "lenny" ]; then
896    METADATA_VERSION="-e0"
897 fi
898
899 ERRORFILE=$(mktemp)
900 # shellcheck disable=SC2086
901 yes | mdadm --create "${TARGET}" --level="${RAIDLEVEL}" \
902       --raid-devices="${NUM_PARTITIONS}" ${METADATA_VERSION} ${SELECTED_PARTITIONS} >/dev/null 2>$ERRORFILE
903 RC=$?
904 if [ "$RC" = 0 ] ; then
905    dialog --title "$PN" --msgbox \
906    "Creating $TARGET was successful." 0 0
907    rm -f "$TMPFILE" "$ERRORFILE"
908 else
909    dialog --title "$PN" --msgbox \
910    "There was an error setting up $TARGET:
911
912 $(cat "$ERRORFILE")
913
914 Exiting." 0 0
915    rm -f "$TMPFILE" "$ERRORFILE"
916    bailout 1
917 fi
918
919 }
920
921 prompt_for_swraid()
922 {
923 if dialog --stdout --title "$PN" \
924           --defaultno --yesno "Do you want to configure Software RAID?
925
926 Please notice that only RAID level 1 is supported by ${PN} currently. Configuration will take place using mdadm." 0 0 ; then
927   config_swraid_setup
928 fi
929 }
930 # }}}
931
932 # user should recheck his configuration {{{
933 # support full automatic installation:
934 checkforrun() {
935    dialog --timeout 10 --title "$PN" \
936           --yesno "Do you want to stop at this stage?
937
938 Notice: you are running ${PN} in non-interactive mode.
939 ${PN} will install Debian ${RELEASE} on ${TARGET}.
940 Last chance to quit. Timeout of 10 seconds running....
941
942 Do you want to stop now?" 0 0 2>/dev/null
943 }
944 # }}}
945
946 # format efi partition {{{
947 format_efi_partition() {
948   if [ -z "$EFI" ] ; then
949     return 0
950   fi
951
952   if ! [ -b "$EFI" ] ; then
953     eerror "Specified efi argument [$EFI] not a valid block device."
954     bailout 1
955   fi
956
957   if fsck.vfat -bn "$EFI" >/dev/null; then
958     einfo "EFI partition $EFI seems to have a FAT filesystem, not modifying." ; eend 0
959   else
960     einfo "EFI partition $EFI doesn't seem to be formatted, creating filesystem."
961     mkfs.fat -F32 -n "EFI System Partition" "$EFI"
962     RC=$?
963     if [ $RC -eq 0 ] ; then
964       eend 0
965     else
966       eerror "Error while creating filesystem on ${EFI}."
967       eend 1
968       bailout 1
969     fi
970   fi
971 }
972 # }}}
973
974 # check for EFI support or try to enable it {{{
975 efi_support() {
976   if lsmod | grep -q efivars ; then
977     einfo "EFI support detected." ; eend 0
978     return 0
979   fi
980
981   if modprobe efivars &>/dev/null ; then
982     einfo "EFI support enabled now." ; eend 0
983     return 0
984   fi
985
986   return 1
987 }
988 # }}}
989
990 # make sure the user is aware of the used configuration {{{
991 checkconfiguration()
992 {
993
994 if efi_support ; then
995   if [ -z "$_opt_efi" ] ; then
996     ewarn "EFI support detected but no --efi option given, please consider enabling it." ; eend 0
997   fi
998 else
999   if [ -n "$_opt_efi" ] ; then
1000      eerror "EFI option used but no EFI support detected." ; eend 0
1001      bailout 1
1002   fi
1003 fi
1004
1005 if [ -n "$AUTOINSTALL" ] ; then
1006    if checkforrun ; then
1007       eerror "Exiting as requested" ; eend 0
1008       bailout 1
1009    fi
1010 elif [ -n "$INTERACTIVE" ] ; then
1011
1012    INFOTEXT="Please recheck configuration before execution:
1013    "
1014    [ -n "$TARGET" ]  && INFOTEXT="$INFOTEXT
1015    Target:          $TARGET"
1016    [ -n "$GRUB" ]    && INFOTEXT="$INFOTEXT
1017    Install grub:    $GRUB"
1018    [ -n "$EFI" ]    && INFOTEXT="$INFOTEXT
1019    Install efi:     $EFI"
1020    [ -n "$RELEASE" ] && INFOTEXT="$INFOTEXT
1021    Using release:   $RELEASE"
1022    [ -n "$HOSTNAME" ] && INFOTEXT="$INFOTEXT
1023    Using hostname:  $HOSTNAME"
1024    [ -n "$MIRROR" ]  && INFOTEXT="$INFOTEXT
1025    Using mirror:    $MIRROR"
1026    [ -n "$ISO" ]  && INFOTEXT="$INFOTEXT
1027    Using ISO:       $ISO"
1028    [ -n "$ARCH" ]  && INFOTEXT="$INFOTEXT
1029    Using arch:      $ARCH"
1030    [ -n "$CONFFILES" ] && INFOTEXT="$INFOTEXT
1031    Config files:    $CONFFILES"
1032
1033    INFOTEXT="$INFOTEXT
1034
1035 Is this ok for you? Notice: selecting 'No' will exit ${PN}."
1036
1037    dialog --title "$PN" --no-collapse \
1038           --yesno "$INFOTEXT" 0 0
1039    [ $? -eq 0 ] || bailout 0
1040
1041 else # if not running automatic installation display configuration and prompt for execution:
1042    einfo "$PN [${VERSION}] - Please recheck configuration before execution:"
1043    echo
1044    echo "   Target:          $TARGET"
1045
1046    # do not display if MNTPOINT is the default one
1047    case "$MNTPOINT" in /mnt/debootstrap*) ;; *) echo "   Mount point:     $MNTPOINT" ;; esac
1048
1049    if [ -n "$VIRTUAL" ] ; then
1050       echo "   Install grub:    yes"
1051    else
1052      [ -n "$GRUB" ]     && echo "   Install grub:    $GRUB" || echo "   Install grub:    no"
1053      [ -n "$EFI" ]      && echo "   Install efi:     $EFI"  || echo "   Install efi:     no"
1054    fi
1055
1056    [ -n "$RELEASE" ]   && echo "   Using release:   $RELEASE"
1057    [ -n "$HOSTNAME" ]  && echo "   Using hostname:  $HOSTNAME"
1058    [ -n "$MIRROR" ]    && echo "   Using mirror:    $MIRROR"
1059    [ -n "$ISO" ]       && echo "   Using ISO:       $ISO"
1060    [ -n "$ARCH" ]      && echo "   Using arch:      $ARCH"
1061    [ -n "$CONFFILES" ] && echo "   Config files:    $CONFFILES"
1062    if [ -n "$VIRTUAL" ] ; then
1063       echo "   Deploying as Virtual Machine."
1064       if [ -n "$VMSIZE" ] && [ -n "$VMFILE" ]; then
1065          echo "   Using Virtual Disk file with size of ${VMSIZE}."
1066       fi
1067    fi
1068
1069    if [ ! -t 0 ] && [ -z "$ROOTPASSWORD" ] && [ -z "$NOPASSWORD" ] ; then
1070       echo
1071       echo "   You do not have a TTY allocated, your password will be shown in"
1072       echo "   plaintext on the terminal! If you are using SSH, try its -t option!"
1073    fi
1074
1075    echo
1076    echo "   Important! Continuing will delete all data from ${TARGET}!"
1077
1078    if [ -n "$FORCE" ] ; then
1079      einfo "Skip user acknowledgement as requested via --force option."
1080    else
1081      echo
1082      einfon "Is this ok for you? [y/N] "
1083      read -r a
1084      if ! [ "$a" = 'y' ] || [ "$a" = 'Y' ] ; then
1085         eerror "Exiting as requested." ; eend 1
1086         bailout 1
1087      fi
1088    fi
1089 fi
1090 }
1091 # }}}
1092
1093 # interactive mode {{{
1094 interactive_mode()
1095 {
1096   check4progs dialog || bailout 1
1097
1098   welcome_dialog
1099
1100   prompt_for_release
1101
1102   prompt_for_swraid
1103
1104   prompt_for_target
1105
1106   prompt_for_bootmanager
1107
1108   prompt_for_hostname
1109
1110   prompt_for_password
1111
1112   prompt_for_mirror
1113 }
1114
1115 # run interactive mode if we didn't get the according configuration yet
1116 if [ -z "$TARGET" ] || [ -n "$INTERACTIVE" ] ; then
1117    # only target might be unset, so make sure the INTERACTIVE flag is set as well
1118    INTERACTIVE=1
1119    interactive_mode
1120 fi
1121 # }}}
1122
1123 # architecture setup {{{
1124 if [ -n "$ARCH" ] ; then
1125    ARCHCMD="--arch $ARCH"
1126    ARCHINFO=" (${ARCH})"
1127 else
1128    ARCH="$(dpkg --print-architecture)"
1129    ARCHCMD="--arch $ARCH"
1130    ARCHINFO=" (${ARCH})"
1131 fi
1132 # }}}
1133
1134 # It is not possible to build amd64 on i686. {{{
1135 CURRENT_ARCH="$(uname -m)"
1136 if [ "$CURRENT_ARCH" != "x86_64" ] ; then
1137    if [ "$ARCH" = "amd64" ] ; then
1138       eerror "It is not possible to build amd64 on $CURRENT_ARCH. Consider installing and booting the 'linux-image-amd64' kernel or using '--arch i386' instead." ; eend 1
1139       bailout 1
1140    fi
1141 fi
1142 # }}}
1143
1144 # Support for generic release codenames is unavailable. {{{
1145 if [ "$RELEASE" = "stable" ] || [ "$RELEASE" = "testing" ] ; then
1146    eerror "Generic release codenames (stable, testing) are unsupported. \
1147 Please use specific codenames such as stretch or buster." ; eend 1
1148    bailout 1
1149 fi
1150 # }}}
1151
1152 checkconfiguration
1153
1154 # finally make sure at least $TARGET is set [the partition for the new system] {{{
1155 if [ -n "$TARGET" ] ; then
1156    SHORT_TARGET="${TARGET##*/}"
1157 else
1158    eerror "Please adjust $CONFFILES/config or..."
1159    eerror "... use the interactive version for configuration before running ${0}" ; eend 1
1160    bailout 1
1161 fi
1162 # }}}
1163
1164 # stages setup {{{
1165 if [ -z "$STAGES" ] ; then
1166    STAGES="/var/cache/grml-debootstrap/stages_${SHORT_TARGET}"
1167    [ -d "$STAGES" ] || mkdir -p "$STAGES"
1168 fi
1169
1170 if [ -r "$STAGES"/grml-debootstrap ] ; then
1171    if grep -q 'done' "${STAGES}/grml-debootstrap" ; then
1172       eerror "Error: grml-debootstrap has been executed already, won't continue therefore."
1173       eerror "If you want to re-execute grml-debootstrap just manually remove ${STAGES}" ; eend 1
1174    fi
1175 fi
1176 # }}}
1177
1178 # partition handling {{{
1179 PARTITION=''
1180 DIRECTORY=''
1181
1182 set_target_directory(){
1183     # assume we are installing into a directory, don't run mkfs and grub related stuff therefore
1184     DIRECTORY=1
1185     MNTPOINT="$TARGET"
1186     MKFS=''
1187     TUNE2FS=''
1188     FSCK=''
1189     # make sure we normalise the path to an absolute directory name so something like:
1190     #  mkdir -p foo/a bar/a; (cd foo; grml-debootstrap -t a)&; (cd bar; grml-debootstrap -t a)&; wait
1191     # works
1192     TARGET="$(readlink -f "$TARGET")"
1193 }
1194
1195 if [ -b "$TARGET" ] || [ -n "$VIRTUAL" ] ; then
1196     PARTITION=1
1197 else
1198     # $TARGET was not detected as block device, but we do not want to create target directory in /dev/
1199     if [[ $TARGET == "/dev/"* ]]; then
1200       eerror "Error: Will not create target directory $TARGET in /dev."
1201       eerror "  Please check the partition(s) of the blockdevice."; eend 1
1202       bailout 1
1203     fi
1204     set_target_directory
1205 fi
1206 # }}}
1207
1208 # make sure we have the right syntax when using an iso image {{{
1209 if [ -n "$ISO" ] ; then
1210    case $ISO in
1211       file*) # do nothing
1212       ;;
1213       *)
1214       ISO=file:$ISO
1215       ;;
1216    esac
1217 fi
1218 ISODIR=${ISO##file:}
1219 ISODIR=${ISODIR%%/}
1220 # }}}
1221
1222 # Debian ISOs do not contain signed Release files {{{
1223 if [ -n "$ISO" ] ; then
1224     DEBOOTSTRAP_OPT="$DEBOOTSTRAP_OPT --no-check-gpg"
1225 fi
1226 # }}}
1227
1228 # create filesystem {{{
1229 mkfs() {
1230   if [ -n "$DIRECTORY" ] ; then
1231      einfo "Running grml-debootstrap on a directory, skipping mkfs stage."
1232      return 0
1233   fi
1234
1235   if grep -q "$TARGET" /proc/mounts ; then
1236     eerror "$TARGET already mounted, exiting to avoid possible damage. (Manually unmount $TARGET)" ; eend 1
1237     bailout 1
1238   fi
1239
1240   # mkfs.ext* might prompt with "/dev/sdX# contains a ext* file system
1241   # created on ... Proceed anyway? (y,n)" which we want to skip in force mode
1242   if [ -n "$MKFS" ] && [ -n "$FORCE" ] ; then
1243     case "$MKFS" in
1244       mkfs.ext*)
1245         einfo "Enabling force option (-F) for mkfs.ext* tool as requested via --force switch."
1246         MKFS_OPTS="$MKFS_OPTS -F"
1247         eend 0
1248
1249         ;;
1250     esac
1251   fi
1252
1253   # starting with e2fsprogs 1.43~WIP.2015.05.18-1 mkfs.ext4 enables the metadata_csum feature
1254   # by default, which requires a recent version of tune2fs on the target system then,
1255   # so disable this feature for older Debian releases where it's known to be unsupported
1256   if [ -n "$MKFS" ] && [ "$MKFS" = "mkfs.ext4" ] ; then
1257     case "$RELEASE" in
1258       lenny|squeeze|wheezy|jessie)
1259         # assume a more recent version if we can't identify the version via dpkg-query
1260         local e2fsprogs_version
1261         e2fsprogs_version="$(dpkg-query --show --showformat='${Version}' e2fsprogs 2>/dev/null || echo 1.44)"
1262         if [ -n "$e2fsprogs_version" ] && dpkg --compare-versions "$e2fsprogs_version" ge '1.43~WIP.2015.05.18-1' ; then
1263           einfo "Disabling metadata_csum feature for $MKFS as $RELEASE doesn't support it."
1264           MKFS_OPTS="$MKFS_OPTS -O ^metadata_csum"
1265           eend 0
1266         fi
1267         ;;
1268     esac
1269   fi
1270
1271   if [ -n "$MKFS" ] ; then
1272     einfo "Running $MKFS $MKFS_OPTS on $TARGET"
1273     # shellcheck disable=SC2086
1274     "$MKFS" $MKFS_OPTS "$TARGET" ; RC=$?
1275
1276     if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1277       if ! echo "$MKFS" | grep -q "mkfs.ext" ; then
1278         eerror "Not changing disk uuid for $TARGET because $MKFS doesn't seem to match for ext{2,3,4} file system"
1279         eend 1
1280         bailout 1
1281       else
1282         einfo "Changing disk uuid for $TARGET to fixed (non-random) value $DISK_IDENTIFIER using tune2fs"
1283         tune2fs "$TARGET" -U "$DISK_IDENTIFIER"
1284         eend $?
1285       fi
1286     fi
1287
1288     # make sure /dev/disk/by-uuid/... is up2date, otherwise grub
1289     # will fail to detect the uuid in the chroot
1290     if [ -n "$VIRTUAL" ] ; then
1291       einfo "Virtual environment doesn't require blockdev --rereadpt, skipping therefore"
1292     elif echo "$TARGET" | grep -q "/dev/md" ; then
1293       blockdev --rereadpt "${TARGET}"
1294     else
1295       # if we deploy to /dev/sdX# then let's see if /dev/sdX exists
1296       local main_device="${TARGET%%[0-9]*}"
1297       # sanity check to not try to e.g. access /dev/loop if we get /dev/loop0
1298       if [ -f "/sys/block/$(basename "${main_device}")/$(basename "${TARGET}")/dev" ] ; then
1299         blockdev --rereadpt "$main_device"
1300       else
1301         einfo "No underlying block device for $TARGET identified, skipping blockdev --rereadpt."
1302       fi
1303     fi
1304     # give the system 2 seconds, otherwise we might run into
1305     # race conditions :-/
1306     sleep 2
1307
1308     eend $RC
1309   fi
1310 }
1311 # }}}
1312
1313 # retrieve ID_FS_UUID {{{
1314 identify_target_uuid() {
1315   local device="$1"
1316
1317   if ! [ -b "$device" ] ; then
1318     return 1
1319   fi
1320
1321   eval "$(blkid -o udev "$1" 2>/dev/null)"
1322
1323   if [ -n "$ID_FS_UUID" ] ; then
1324     echo "$ID_FS_UUID"
1325   else
1326     return 1
1327   fi
1328 }
1329 # }}}
1330
1331 # identify TARGET_UUID {{{
1332 mountpoint_to_blockdevice() {
1333   TARGET_UUID=''
1334
1335   TARGET_UUID=$(identify_target_uuid "$TARGET" 2>/dev/null || true)
1336   if [ -n "$TARGET_UUID" ] ; then
1337     einfo "Identified UUID $TARGET_UUID for $TARGET"
1338     return 0
1339   fi
1340
1341   # $TARGET might be a mountpoint and not a blockdevice, search for according entry
1342   for file in /sys/block/*/*/dev ; do
1343     if grep -q "^$(mountpoint -d "${TARGET}")$" "$file" ; then
1344       local dev
1345       dev="${file%/dev}"
1346       dev="/dev/${dev##*/}"
1347       TARGET_UUID=$(identify_target_uuid "$dev" 2>/dev/null || true)
1348
1349       if [ -n "$TARGET_UUID" ] ; then
1350         einfo "Identified UUID $TARGET_UUID for $TARGET (via $file)"
1351         return 0
1352       fi
1353     fi
1354   done
1355 }
1356 # }}}
1357
1358 # modify filesystem settings {{{
1359 tunefs() {
1360   if [ -n "$TUNE2FS" ] && echo "$MKFS" | grep -q "mkfs.ext" ; then
1361      einfo "Disabling automatic filesystem check on $TARGET via tune2fs"
1362      $TUNE2FS "$TARGET"
1363      eend $?
1364   fi
1365 }
1366 # }}}
1367
1368 # mount the new partition or if it's a directory do nothing at all {{{
1369 mount_target() {
1370   if [ -n "$DIRECTORY" ] ; then
1371      einfo "Running grml-debootstrap on a directory, nothing to mount."
1372   else
1373      if grep -q "$TARGET" /proc/mounts ; then
1374         ewarn "$TARGET already mounted, continuing anyway." ; eend 0
1375      else
1376        if ! [ -d "${MNTPOINT}" ] ; then
1377           [ -n "$VIRTUAL" ] || mkdir -p "${MNTPOINT}"
1378        fi
1379        einfo "Mounting $TARGET to $MNTPOINT"
1380        mkdir -p "$MNTPOINT"
1381        mount -o rw,suid,dev "$TARGET" "$MNTPOINT"
1382        eend $?
1383      fi
1384   fi
1385   if [ -n "$ISODIR" ] ; then
1386      einfo "Mounting Debian image loopback to $MNTPOINT/$ISODIR."
1387      mkdir -p "$MNTPOINT/$ISODIR"
1388      mount --bind "$ISODIR" "$MNTPOINT/$ISODIR"
1389      eend $?
1390   fi
1391 }
1392 # }}}
1393
1394 # prepare VM image for usage with debootstrap {{{
1395 prepare_vm() {
1396   if [ -z "$VIRTUAL" ] ; then
1397      return 0 # be quiet by intention
1398   fi
1399
1400   if [ -b "$TARGET" ] && [ -n "$VMFILE" ] ; then
1401      eerror "Error: specified virtual disk target ($TARGET) is an existing block device."
1402      eend 1
1403      bailout 1
1404   fi
1405   if [ ! -b "$TARGET" ] && [ -z "$VMFILE" ] ; then
1406      eerror "Error: specified virtual disk target ($TARGET) does not exist yet."
1407      eend 1
1408      bailout 1
1409   fi
1410
1411   # make sure loop module is present and a usable loop device exists
1412   modprobe -q loop
1413   if ! losetup -f >/dev/null 2>&1; then
1414     eerror "Error finding usable loop device" ; eend 1
1415     bailout 1
1416   fi
1417
1418   # if dm-mod isn't available then kpartx will fail with
1419   # "Is device-mapper driver missing from kernel? [...]"
1420   modprobe -q dm-mod
1421   if ! grep -q 'device-mapper' /proc/misc >/dev/null 2>&1 ; then
1422     eerror "Device-mapper support missing in kernel." ; eend 1
1423     bailout 1
1424   fi
1425
1426   ORIG_TARGET="$TARGET" # store for later reuse
1427
1428   if [ -n "$VMFILE" ]; then
1429     qemu-img create -f raw "${TARGET}" "${VMSIZE}"
1430   fi
1431   parted -s "${TARGET}" 'mklabel msdos'
1432   if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1433     einfo "Adjusting disk signature to a fixed (non-random) value"
1434     MBRTMPFILE=$(mktemp)
1435     dd if="${TARGET}" of="${MBRTMPFILE}" bs=512 count=1
1436     echo -en "\\x41\\x41\\x41\\x41" | dd of="${MBRTMPFILE}" conv=notrunc seek=440 bs=1
1437     dd if="${MBRTMPFILE}" of="${TARGET}" conv=notrunc
1438     eend $?
1439   fi
1440   parted -s "${TARGET}" 'mkpart primary ext4 2M -1'
1441   parted -s "${TARGET}" 'set 1 boot on'
1442
1443   DEVINFO=$(kpartx -asv "$TARGET") # e.g. 'add map loop0p1 (254:5): 0 20477 linear 7:0 3'
1444   if [ -z "${DEVINFO}" ] ; then
1445     eerror "Error setting up loopback device." ; eend 1
1446     bailout 1
1447   fi
1448
1449   # hopefully this always works as expected
1450   LOOP_PART="${DEVINFO##add map }" # 'loop0p1 (254:5): 0 20477 linear 7:0 3'
1451   LOOP_PART="${LOOP_PART// */}"    # 'loop0p1'
1452   LOOP_DISK="${LOOP_PART%p*}"      # 'loop0'
1453   export TARGET="/dev/mapper/$LOOP_PART" # '/dev/mapper/loop1p1'
1454
1455   if [ -z "$TARGET" ] ; then
1456      eerror "Error: target could not be set to according /dev/mapper/* device." ; eend 1
1457      bailout 1
1458   fi
1459 }
1460 # }}}
1461
1462 # make VM image bootable {{{
1463 grub_install() {
1464   if [ -z "${VIRTUAL}" ] ; then
1465      return 0
1466   fi
1467   if [ "${GRUB_INSTALL}" != "yes" ] ; then
1468     einfo "Not installing GRUB as requested via \$GRUB_INSTALL=$GRUB_INSTALL"
1469     return 0
1470   fi
1471
1472   if ! mount "${TARGET}" "${MNTPOINT}" ; then
1473     eerror "Error: Mounting ${TARGET} failed, can not continue." ; eend 1
1474     bailout 1
1475   fi
1476
1477   mount -t proc none "${MNTPOINT}"/proc
1478   mount -t sysfs none "${MNTPOINT}"/sys
1479   mount -t devtmpfs udev "${MNTPOINT}"/dev
1480   mount -t devpts devpts "${MNTPOINT}"/dev/pts
1481
1482 # Has chroot-script installed GRUB to MBR using grub-install (successfully), already?
1483 # chroot-script skips installation for unset ${GRUB}
1484 if [[ -z "${GRUB}" ]] || ! dd if="${GRUB}" bs=512 count=1 2>/dev/null | cat -v | grep -Fq GRUB; then
1485   einfo "Installing Grub as bootloader."
1486
1487   if ! chroot "${MNTPOINT}" dpkg --list grub-pc 2>/dev/null | grep -q '^ii' ; then
1488     echo "Notice: grub-pc package not present yet, installing it therefore."
1489     # shellcheck disable=SC2086
1490     DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y install $DPKG_OPTIONS grub-pc
1491   fi
1492
1493   mkdir -p "${MNTPOINT}/boot/grub"
1494   if ! [ -d "${MNTPOINT}"/usr/lib/grub/i386-pc/ ] ; then
1495      eerror "Error: grub not installed inside Virtual Machine. Can not install bootloader." ; eend 1
1496      bailout 1
1497   fi
1498
1499   case "$RELEASE" in
1500     lenny|squeeze|wheezy)
1501       cp "${MNTPOINT}"/usr/lib/grub/i386-pc/* "${MNTPOINT}/boot/grub/"
1502       ;;
1503     *)
1504       cp -a "${MNTPOINT}"/usr/lib/grub/i386-pc "${MNTPOINT}/boot/grub/"
1505       ;;
1506   esac
1507   dd if="${MNTPOINT}/usr/lib/grub/i386-pc/boot.img" of="${ORIG_TARGET}" conv=notrunc bs=440 count=1
1508   chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos ext2
1509   dd if="${MNTPOINT}/tmp/core.img" of="${ORIG_TARGET}" conv=notrunc seek=1
1510   rm -f "${MNTPOINT}/tmp/core.img"
1511 fi
1512
1513   einfo "Updating grub configuration file."
1514   if [ -n "$BOOT_APPEND" ] ; then
1515      sed -i "/GRUB_CMDLINE_LINUX_DEFAULT/ s#\"\$# ${BOOT_APPEND}\"#" "${MNTPOINT}"/etc/default/grub
1516   fi
1517   chroot "${MNTPOINT}" update-grub
1518
1519   case "$RELEASE" in
1520     jessie)
1521       einfo "Applying workaround for GRUB font path bug in jessie (Debian #787685)."
1522       mkdir -p "${MNTPOINT}/boot/grub/fonts/"
1523       cp "${MNTPOINT}/usr/share/grub/unicode.pf2" "${MNTPOINT}/boot/grub/fonts/"
1524       ;;
1525   esac
1526
1527   if grep -q '^GRUB_DISABLE_LINUX_UUID=.*true' "${MNTPOINT}"/etc/default/grub 2>/dev/null ; then
1528     ewarn "GRUB_DISABLE_LINUX_UUID is set to true in /etc/default/grub, not adjusting root= in grub.cfg."
1529     ewarn "Please note that your system might NOT be able to properly boot."
1530   else
1531     einfo "Adjusting grub.cfg for successful boot sequence."
1532     sed -i "s;root=[^ ]\\+;root=UUID=$TARGET_UUID;" "${MNTPOINT}"/boot/grub/grub.cfg
1533   fi
1534
1535   umount "${MNTPOINT}"/proc
1536   umount "${MNTPOINT}"/sys
1537   umount "${MNTPOINT}"/dev/pts
1538   try_umount 3 "${MNTPOINT}"/dev
1539
1540 }
1541 # }}}
1542
1543 # unmount VM image {{{
1544 umount_target() {
1545   if [ -z "${VIRTUAL}" ] ; then
1546      return 0
1547   fi
1548
1549   umount "${MNTPOINT}"
1550   kpartx -d "${ORIG_TARGET}" >/dev/null
1551   # Workaround for a bug in kpartx which doesn't clean up properly,
1552   # see Debian Bug #891077 and Github-PR grml/grml-debootstrap#112
1553   if dmsetup ls | grep -q "^${LOOP_PART} "; then
1554     kpartx -d "/dev/${LOOP_DISK}" >/dev/null
1555   fi
1556 }
1557 # }}}
1558
1559 # install main chroot {{{
1560 debootstrap_system() {
1561   if [ "$_opt_nodebootstrap" ]; then
1562      einfo "Skipping debootstrap as requested."
1563      return
1564   fi
1565
1566   if grep -q "$MNTPOINT" /proc/mounts || [ -n "$DIRECTORY" ] ; then
1567     :
1568   else
1569     eerror "Error: $MNTPOINT not mounted, can not continue."
1570     eend 1 ; exit 1
1571   fi
1572
1573   if [ -n "$ISO" ] ; then
1574     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${ISO}"
1575     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO"
1576     # shellcheck disable=SC2086
1577     "$DEBOOTSTRAP" $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$ISO"
1578     RC=$?
1579   else
1580     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${MIRROR}"
1581     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR"
1582     # shellcheck disable=SC2086
1583     "$DEBOOTSTRAP" $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$MIRROR"
1584     RC=$?
1585   fi
1586
1587   if [ $RC -ne 0 ] ; then
1588     if [ -r "$MNTPOINT/debootstrap/debootstrap.log" ] && \
1589       [ -s "$MNTPOINT/debootstrap/debootstrap.log" ] ; then
1590       einfo "Presenting last ten lines of debootstrap.log:"
1591       tail -10 "${MNTPOINT}"/debootstrap/debootstrap.log
1592       einfo "End of debootstrap.log"
1593     fi
1594   fi
1595
1596   eend $RC
1597 }
1598 # }}}
1599
1600 # prepare chroot via chroot-script {{{
1601 preparechroot() {
1602   einfo "Preparing chroot system"
1603
1604   # provide variables to chroot system
1605   CHROOT_VARIABLES="/var/cache/grml-debootstrap/variables_${SHORT_TARGET}"
1606   touch "$CHROOT_VARIABLES"
1607   chmod 600 "$CHROOT_VARIABLES" # make sure nobody except root can read it
1608   echo "# Configuration of ${PN}"                                                                                   > "$CHROOT_VARIABLES"
1609   # Resorting to sed(1) for escaping since "VAR='${VAR//\'/\'\\\'\'}'" does not work with all versions of Bash,
1610   #   e.g. not with 4.2.37(1)-release (a.k.a 4.2+dfsg-0.1+deb7u3) of Debian wheezy
1611   [ -n "$ARCH" ]                && echo "ARCH='$(sed "s,','\\\\'',g" <<<"${ARCH}")'"                               >> "$CHROOT_VARIABLES"
1612   [ -n "$BACKPORTREPOS" ]       && echo "BACKPORTREPOS='$(sed "s,','\\\\'',g" <<<"${BACKPORTREPOS}")'"             >> "$CHROOT_VARIABLES"
1613   [ -n "$CHROOT_SCRIPTS" ]      && echo "CHROOT_SCRIPTS='$(sed "s,','\\\\'',g" <<<"${CHROOT_SCRIPTS}")'"           >> "$CHROOT_VARIABLES"
1614   [ -n "$COMPONENTS" ]          && echo "COMPONENTS='$(sed "s,','\\\\'',g" <<<"${COMPONENTS}")'"                   >> "$CHROOT_VARIABLES"
1615   [ -n "$CONFFILES" ]           && echo "CONFFILES='$(sed "s,','\\\\'',g" <<<"${CONFFILES}")'"                     >> "$CHROOT_VARIABLES"
1616   [ -n "$DEBCONF" ]             && echo "DEBCONF='$(sed "s,','\\\\'',g" <<<"${DEBCONF}")'"                         >> "$CHROOT_VARIABLES"
1617   [ -n "$DEBIAN_FRONTEND" ]     && echo "DEBIAN_FRONTEND='$(sed "s,','\\\\'',g" <<<"${DEBIAN_FRONTEND}")'"         >> "$CHROOT_VARIABLES"
1618   [ -n "$DEBOOTSTRAP" ]         && echo "DEBOOTSTRAP='$(sed "s,','\\\\'',g" <<<"${DEBOOTSTRAP}")'"                 >> "$CHROOT_VARIABLES"
1619   [ -n "$DEFAULT_LOCALES" ]     && echo "DEFAULT_LOCALES='$(sed "s,','\\\\'',g" <<<"${DEFAULT_LOCALES}")'"         >> "$CHROOT_VARIABLES"
1620   [ -n "$DEFAULT_LANGUAGE" ]    && echo "DEFAULT_LANGUAGE='$(sed "s,','\\\\'',g" <<<"${DEFAULT_LANGUAGE}")'"       >> "$CHROOT_VARIABLES"
1621   [ -n "$EXTRAPACKAGES" ]       && echo "EXTRAPACKAGES='$(sed "s,','\\\\'',g" <<<"${EXTRAPACKAGES}")'"             >> "$CHROOT_VARIABLES"
1622   [ -n "$EFI" ]                 && echo "EFI='$(sed "s,','\\\\'',g" <<<"${EFI}")'"                                 >> "$CHROOT_VARIABLES"
1623   [ -n "$FALLBACK_MIRROR" ]     && echo "FALLBACK_MIRROR='$(sed "s,','\\\\'',g" <<<"${FALLBACK_MIRROR}")'"         >> "$CHROOT_VARIABLES"
1624   [ -n "$FORCE" ]               && echo "FORCE='$(sed "s,','\\\\'',g" <<<"${FORCE}")'"                             >> "$CHROOT_VARIABLES"
1625   [ -n "$GRMLREPOS" ]           && echo "GRMLREPOS='$(sed "s,','\\\\'',g" <<<"${GRMLREPOS}")'"                     >> "$CHROOT_VARIABLES"
1626   [ -n "$GRUB" ]                && echo "GRUB='$(sed "s,','\\\\'',g" <<<"${GRUB}")'"                               >> "$CHROOT_VARIABLES"
1627   [ -n "$HOSTNAME" ]            && echo "HOSTNAME='$(sed "s,','\\\\'',g" <<<"${HOSTNAME}")'"                       >> "$CHROOT_VARIABLES"
1628   [ -n "$INITRD" ]              && echo "INITRD='$(sed "s,','\\\\'',g" <<<"${INITRD}")'"                           >> "$CHROOT_VARIABLES"
1629   [ -n "$INSTALL_NOTES" ]       && echo "INSTALL_NOTES='$(sed "s,','\\\\'',g" <<<"${INSTALL_NOTES}")'"             >> "$CHROOT_VARIABLES"
1630   [ -n "$ISODIR" ]              && echo "ISODIR='$(sed "s,','\\\\'',g" <<<"${ISO}")'"                              >> "$CHROOT_VARIABLES"
1631   [ -n "$ISO" ]                 && echo "ISO='$(sed "s,','\\\\'',g" <<<"${ISO}")'"                                 >> "$CHROOT_VARIABLES"
1632   [ -n "$KEEP_SRC_LIST" ]       && echo "KEEP_SRC_LIST='$(sed "s,','\\\\'',g" <<<"${KEEP_SRC_LIST}")'"             >> "$CHROOT_VARIABLES"
1633   [ -n "$LOCALES" ]             && echo "LOCALES='$(sed "s,','\\\\'',g" <<<"${LOCALES}")'"                         >> "$CHROOT_VARIABLES"
1634   [ -n "$MIRROR" ]              && echo "MIRROR='$(sed "s,','\\\\'',g" <<<"${MIRROR}")'"                           >> "$CHROOT_VARIABLES"
1635   [ -n "$MKFS" ]                && echo "MKFS='$(sed "s,','\\\\'',g" <<<"${MKFS}")'"                               >> "$CHROOT_VARIABLES"
1636   [ -n "$NOPASSWORD" ]          && echo "NOPASSWORD=\"true\""                                                      >> "$CHROOT_VARIABLES"
1637   [ -n "$NOKERNEL" ]            && echo "NOKERNEL=\"true\""                                                        >> "$CHROOT_VARIABLES"
1638   [ -n "$PACKAGES" ]            && echo "PACKAGES='$(sed "s,','\\\\'',g" <<<"${PACKAGES}")'"                       >> "$CHROOT_VARIABLES"
1639   [ -n "$POST_SCRIPTS" ]        && echo "POST_SCRIPTS='$(sed "s,','\\\\'',g" <<<"${POST_SCRIPTS}")'"               >> "$CHROOT_VARIABLES"
1640   [ -n "$PRE_SCRIPTS" ]         && echo "PRE_SCRIPTS='$(sed "s,','\\\\'',g" <<<"${PRE_SCRIPTS}")'"                 >> "$CHROOT_VARIABLES"
1641   [ -n "$RECONFIGURE" ]         && echo "RECONFIGURE='$(sed "s,','\\\\'',g" <<<"${RECONFIGURE}")'"                 >> "$CHROOT_VARIABLES"
1642   [ -n "$RELEASE" ]             && echo "RELEASE='$(sed "s,','\\\\'',g" <<<"${RELEASE}")'"                         >> "$CHROOT_VARIABLES"
1643   [ -n "$RM_APTCACHE" ]         && echo "RM_APTCACHE='$(sed "s,','\\\\'',g" <<<"${RM_APTCACHE}")'"                 >> "$CHROOT_VARIABLES"
1644   [ -n "$ROOTPASSWORD" ]        && echo "ROOTPASSWORD='$(sed "s,','\\\\'',g" <<<"${ROOTPASSWORD}")'"               >> "$CHROOT_VARIABLES"
1645   [ -n "$SCRIPTS" ]             && echo "SCRIPTS='$(sed "s,','\\\\'',g" <<<"${SCRIPTS}")'"                         >> "$CHROOT_VARIABLES"
1646   [ -n "$SECURE" ]              && echo "SECURE='$(sed "s,','\\\\'',g" <<<"${SECURE}")'"                           >> "$CHROOT_VARIABLES"
1647   [ -n "$SELECTED_PARTITIONS" ] && echo "SELECTED_PARTITIONS='$(sed "s,','\\\\'',g" <<<"${SELECTED_PARTITIONS}")'" >> "$CHROOT_VARIABLES"
1648   [ -n "$TARGET" ]              && echo "TARGET='$(sed "s,','\\\\'',g" <<<"${TARGET}")'"                           >> "$CHROOT_VARIABLES"
1649   [ -n "$UPGRADE_SYSTEM" ]      && echo "UPGRADE_SYSTEM='$(sed "s,','\\\\'',g" <<<"${UPGRADE_SYSTEM}")'"           >> "$CHROOT_VARIABLES"
1650   [ -n "$TARGET_UUID" ]         && echo "TARGET_UUID='$(sed "s,','\\\\'',g" <<<"${TARGET_UUID}")'"                 >> "$CHROOT_VARIABLES"
1651   [ -n "$TIMEZONE" ]            && echo "TIMEZONE='$(sed "s,','\\\\'',g" <<<"${TIMEZONE}")'"                       >> "$CHROOT_VARIABLES"
1652   [ -n "$TUNE2FS" ]             && echo "TUNE2FS='$(sed "s,','\\\\'',g" <<<"${TUNE2FS}")'"                         >> "$CHROOT_VARIABLES"
1653   [ -n "$VMSIZE" ]              && echo "VMSIZE='$(sed "s,','\\\\'',g" <<<"${VMSIZE}")'"                           >> "$CHROOT_VARIABLES"
1654
1655   cp $VERBOSE "${CONFFILES}"/chroot-script "${MNTPOINT}"/bin/chroot-script
1656   chmod 755 "${MNTPOINT}"/bin/chroot-script
1657   [ -d "$MNTPOINT"/etc/debootstrap/ ] || mkdir "$MNTPOINT"/etc/debootstrap/
1658
1659   # make sure we have our files for later use via chroot-script
1660   cp $VERBOSE "${CONFFILES}/config"           "${MNTPOINT}"/etc/debootstrap/
1661   # make sure we adjust the configuration variables accordingly:
1662   sed -i "s#RELEASE=.*#RELEASE=\"$RELEASE\"#" "${MNTPOINT}"/etc/debootstrap/config
1663   sed -i "s#TARGET=.*#TARGET=\"$TARGET\"#"    "${MNTPOINT}"/etc/debootstrap/config
1664   sed -i "s#GRUB=.*#GRUB=\"$GRUB\"#"          "${MNTPOINT}"/etc/debootstrap/config
1665
1666   # install notes:
1667   if [ -n "$INSTALL_NOTES" ] ; then
1668      [ -r "$INSTALL_NOTES" ] && cp "$INSTALL_NOTES" "${MNTPOINT}"/etc/debootstrap/
1669   fi
1670
1671   # package selection:
1672   if [ "$PACKAGES" = 'yes' ] ; then
1673     cp $VERBOSE "${_opt_packages:-$CONFFILES/packages}" \
1674       "${MNTPOINT}"/etc/debootstrap/packages
1675   fi
1676
1677   # debconf preseeding:
1678   _opt_debconf=${_opt_debconf:-$CONFFILES/debconf-selections}
1679   [ -f "${_opt_debconf}" ] && [ "$DEBCONF" = 'yes' ] && \
1680     cp $VERBOSE "${_opt_debconf}" "${MNTPOINT}"/etc/debootstrap/debconf-selections
1681
1682   # copy scripts that should be executed inside the chroot:
1683   _opt_chroot_scripts=${_opt_chroot_scripts:-$CONFFILES/chroot-scripts/}
1684   [ -d "$_opt_chroot_scripts" ] && [ "$CHROOT_SCRIPTS" = 'yes' ] && {
1685     mkdir -p "${MNTPOINT}"/etc/debootstrap/chroot-scripts
1686     cp -a $VERBOSE "${_opt_chroot_scripts}"/* "${MNTPOINT}"/etc/debootstrap/chroot-scripts/
1687   }
1688
1689   # notice: do NOT use $CHROOT_VARIABLES inside chroot but statically file instead!
1690   cp $VERBOSE "${CHROOT_VARIABLES}" "${MNTPOINT}"/etc/debootstrap/variables
1691
1692   cp $VERBOSE -a -L "${CONFFILES}"/extrapackages/ "${MNTPOINT}"/etc/debootstrap/
1693
1694   # make sure we can access network [relevant for cdebootstrap/mmdebstrap]
1695   [ -f "${MNTPOINT}"/etc/resolv.conf ] || cp $VERBOSE /etc/resolv.conf "${MNTPOINT}"/etc/resolv.conf
1696
1697   # setup default locales
1698   [ -n "$LOCALES" ] && cp $VERBOSE "${CONFFILES}"/locale.gen "${MNTPOINT}"/etc/locale.gen
1699
1700   # MAKEDEV is just a forking bomb crap, let's do it on our own instead :)
1701   ( cd "${MNTPOINT}"/dev && tar zxf /etc/debootstrap/devices.tar.gz )
1702
1703   # copy any existing files to chroot
1704   [ -d "${CONFFILES}"/bin   ] && cp $VERBOSE -a -L "${CONFFILES}"/bin/*   "${MNTPOINT}"/bin/
1705   [ -d "${CONFFILES}"/boot  ] && cp $VERBOSE -a -L "${CONFFILES}"/boot/*  "${MNTPOINT}"/boot/
1706   [ -d "${CONFFILES}"/etc   ] && cp $VERBOSE -a -L "${CONFFILES}"/etc/*   "${MNTPOINT}"/etc/
1707   [ -d "${CONFFILES}"/sbin  ] && cp $VERBOSE -a -L "${CONFFILES}"/sbin/*  "${MNTPOINT}"/sbin/
1708   [ -d "${CONFFILES}"/share ] && cp $VERBOSE -a -L "${CONFFILES}"/share/* "${MNTPOINT}"/share/
1709   [ -d "${CONFFILES}"/usr   ] && cp $VERBOSE -a -L "${CONFFILES}"/usr/*   "${MNTPOINT}"/usr/
1710   [ -d "${CONFFILES}"/var   ] && cp $VERBOSE -a -L "${CONFFILES}"/var/*   "${MNTPOINT}"/var/
1711
1712   # network setup
1713   DEFAULT_INTERFACES="# /etc/network/interfaces - generated by grml-debootstrap
1714
1715 # Include files from /etc/network/interfaces.d when using
1716 # ifupdown v0.7.44 or newer:
1717 #source-directory /etc/network/interfaces.d
1718
1719 auto lo
1720 iface lo inet loopback
1721
1722 allow-hotplug eth0
1723 iface eth0 inet dhcp
1724 "
1725
1726   if [ -n "$NOINTERFACES" ] ; then
1727     einfo "Not installing /etc/network/interfaces as requested via --nointerfaces option" ; eend 0
1728   elif [ -n "$USE_DEFAULT_INTERFACES" ] ; then
1729     einfo "Installing default /etc/network/interfaces as requested via --defaultinterfaces options."
1730     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1731     eend $?
1732   elif [ -n "$VIRTUAL" ] ; then
1733     einfo "Setting up Virtual Machine, installing default /etc/network/interfaces"
1734     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1735     eend $?
1736   elif [ -r /etc/network/interfaces ] ; then
1737     einfo "Copying /etc/network/interfaces from host to target system"
1738     cp $VERBOSE /etc/network/interfaces "${MNTPOINT}/etc/network/interfaces"
1739     eend $?
1740   else
1741     ewarn "Couldn't read /etc/network/interfaces, installing default /etc/network/interfaces"
1742     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1743     eend $?
1744   fi
1745
1746   # install config file providing some example entries
1747   if [ -r /etc/network/interfaces.examples ] && [ ! -r "$MNTPOINT/etc/network/interfaces.examples" ] ; then
1748      cp /etc/network/interfaces.examples "$MNTPOINT/etc/network/interfaces.examples"
1749   fi
1750
1751   if [ -d /run/udev ] ; then
1752     einfo "Setting up bind-mount /run/udev"
1753     mkdir -p "${MNTPOINT}"/run/udev
1754     mount --bind /run/udev "${MNTPOINT}"/run/udev
1755     eend $?
1756   fi
1757
1758   eend 0
1759 }
1760 # }}}
1761
1762 # execute all scripts in /etc/debootstrap/pre-scripts/ {{{
1763 execute_pre_scripts() {
1764   # make sure hostname is set even before chroot-script get executed
1765   echo "$HOSTNAME" > "$MNTPOINT"/etc/hostname
1766
1767   # make sure we have $MNTPOINT available for our scripts
1768   export MNTPOINT
1769
1770   if [ -d "$_opt_pre_scripts" ] || [ "$PRE_SCRIPTS" = 'yes' ] ; then
1771     [ -d "$_opt_pre_scripts" ] && pre_scripts="$_opt_pre_scripts" || pre_scripts="${CONFFILES}/pre-scripts/"
1772     for script in "${pre_scripts}"/* ; do
1773       if [ -x "$script" ] ; then
1774         einfo "Executing pre-script $script"
1775         "$script" ; eend $?
1776       fi
1777     done
1778   fi
1779 }
1780 # }}}
1781
1782 # execute all scripts in /etc/debootstrap/post-scripts/ {{{
1783 execute_post_scripts() {
1784   # make sure we have $MNTPOINT and HOSTNAME available for our scripts
1785   export MNTPOINT
1786   export TARGET_HOSTNAME=$HOSTNAME
1787
1788   if [ -d "$_opt_scripts" ] || [ "$SCRIPTS" = 'yes' ] ; then
1789     # legacy support for /etc/debootstrap/scripts/
1790     [ -d "$_opt_scripts" ] && post_scripts="$_opt_scripts" || post_scripts="${CONFFILES}/scripts/"
1791     ewarn "Deprecation NOTE: --scripts/SCRIPTS are deprecated, please switch to --post-scripts/POST_SCRIPTS instead."
1792   elif [ -d "$_opt_post_scripts" ] || [ "$POST_SCRIPTS" = 'yes' ] ; then
1793     [ -d "$_opt_post_scripts" ] && post_scripts="$_opt_post_scripts" || post_scripts="${CONFFILES}/post-scripts/"
1794   fi
1795
1796   if [ -n "$post_scripts" ] ; then
1797     for script in "${post_scripts}"/* ; do
1798       if [ -x "$script" ] ; then
1799         einfo "Executing post-script $script"
1800         "$script" ; eend $?
1801       fi
1802     done
1803   fi
1804 }
1805 # }}}
1806
1807 # unmount mountpoint {{{
1808 try_umount() {
1809   local tries=$1
1810   local mountpoint="$2"
1811
1812   for (( try=1; try<=tries; try++ )); do
1813     if [[ ${try} -eq ${tries} ]]; then
1814       # Last time, show errors this time
1815       umount "${mountpoint}" && return 0
1816     else
1817       # Not last time, hide errors until fatal
1818       if umount "${mountpoint}" 2>/dev/null ; then
1819         return 0
1820       else
1821         sleep 1
1822       fi
1823     fi
1824   done
1825   return 1  # Tried enough
1826 }
1827 # }}}
1828
1829 # execute chroot-script {{{
1830 chrootscript() {
1831   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
1832     mount_target
1833   fi
1834
1835   if ! [ -x "$MNTPOINT/bin/chroot-script" ] ; then
1836     eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
1837     eend 1
1838   else
1839     einfo "Executing chroot-script now"
1840     mount -t devtmpfs udev "${MNTPOINT}"/dev
1841     mount -t devpts devpts "${MNTPOINT}"/dev/pts
1842     if [ "$DEBUG" = "true" ] ; then
1843       chroot "$MNTPOINT" /bin/bash -x /bin/chroot-script ; RC=$?
1844     else
1845       chroot "$MNTPOINT" /bin/chroot-script ; RC=$?
1846     fi
1847     try_umount 3 "$MNTPOINT"/dev/pts
1848     try_umount 3 "$MNTPOINT"/dev
1849     eend $RC
1850   fi
1851
1852   # finally get rid of chroot-script again, there's no good reason to
1853   # keep it on the installed system
1854   if grep -q GRML_CHROOT_SCRIPT_MARKER "${MNTPOINT}/bin/chroot-script" ; then
1855     einfo "Removing chroot-script again"
1856     rm -f "${MNTPOINT}/bin/chroot-script"
1857     eend $?
1858   else
1859     einfo "Keeping chroot-script as string GRML_CHROOT_SCRIPT_MARKER could not be found"
1860     eend 0
1861   fi
1862 }
1863 # }}}
1864
1865 # unmount $MNTPOINT {{{
1866 umount_chroot() {
1867
1868   # display installation notes:
1869   if [ -n "$INSTALL_NOTES" ] ; then
1870      [ -r "${MNTPOINT}/${INSTALL_NOTES}" ] && cat "${MNTPOINT}/${INSTALL_NOTES}"
1871   fi
1872
1873   if [ -n "$ISODIR" ] ; then
1874      if grep -q "$ISODIR" /proc/mounts ; then
1875         einfo "Unmount $MNTPOINT/$ISODIR"
1876         umount "$MNTPOINT/$ISODIR"
1877         eend $?
1878      fi
1879   fi
1880
1881   if grep -q "$MNTPOINT" /proc/mounts ; then
1882     if mountpoint "${MNTPOINT}"/run/udev &>/dev/null ; then
1883       einfo "Unmounting bind-mount /run/udev"
1884       umount "${MNTPOINT}"/run/udev
1885       eend $?
1886     fi
1887
1888      if [ -n "$PARTITION" ] ; then
1889         einfo "Unmount $MNTPOINT"
1890         umount "$MNTPOINT"
1891         eend $?
1892      fi
1893   fi
1894 }
1895 # }}}
1896
1897 # execute filesystem check {{{
1898 fscktool() {
1899  if [ -n "$VIRTUAL" ] ; then
1900    einfo "Skipping filesystem check because we deploy a virtual machine."
1901    return 0
1902  fi
1903
1904  if [ "$FSCK" = 'yes' ] ; then
1905    [ -n "$FSCKTOOL" ] || FSCKTOOL="fsck.${MKFS#mkfs.}"
1906    einfo "Checking filesystem on $TARGET using $FSCKTOOL"
1907    "$FSCKTOOL" "$TARGET"
1908    eend $?
1909  fi
1910 }
1911 # }}}
1912
1913 # get rid of grml-debootstrap config files {{{
1914 remove_configs() {
1915   if [ "$REMOVE_CONFIGS" != "yes" ] ; then
1916     return 0
1917   fi
1918
1919   if ! mountpoint "${MNTPOINT}" >/dev/null 2>&1 ; then
1920     ewarn "Target ${MNTPOINT} doesn't seem to be mounted, can't remove configuration files." ; eend 0
1921     return 0
1922   fi
1923
1924   einfo "Removing configuration files from installed system as requested via --remove-configs / REMOVE_CONFIGS."
1925   rm -rf "${MNTPOINT}"/etc/debootstrap/
1926   eend $?
1927 }
1928 # }}}
1929
1930 # now execute all the functions {{{
1931 for i in format_efi_partition prepare_vm mkfs tunefs \
1932          mount_target mountpoint_to_blockdevice debootstrap_system \
1933          preparechroot execute_pre_scripts chrootscript execute_post_scripts \
1934          remove_configs umount_chroot grub_install umount_target fscktool ; do
1935     if stage "${i}" ; then
1936       if "$i" ; then
1937         stage "${i}" 'done' && rm -f "${STAGES}/${i}"
1938       else
1939         bailout 2 "$i"
1940       fi
1941     fi
1942 done
1943
1944 cleanup
1945 # }}}
1946
1947 # end dialog of autoinstallation {{{
1948 if [ -n "$AUTOINSTALL" ] ; then
1949    if dialog --title "${PN}" --pause "Finished execution of ${PN}.
1950 Automatically rebooting in 10 seconds.
1951
1952 Choose Cancel to skip rebooting." 10 60 10 ; then
1953      noeject noprompt reboot
1954   fi
1955 else
1956    einfo "Finished execution of ${PN}. Enjoy your Debian system." ; eend 0
1957 fi
1958 # }}}
1959
1960 ## END OF FILE #################################################################
1961 # vim: ai tw=100 expandtab foldmethod=marker shiftwidth=2